# Sisällysluettelo
- [1. Elokuvakirjasto](#1-elokuvakirjasto)
   - [1.1 Mitä tietoja elokuvissa on?](#11-mitä-tietoja-elokuvissa-on)
   - [1.2 Mitä ominaisuuksia kirjastolta halutaan?](#12-mitä-ominaisuuksia-kirjastolta-halutaan)
   - [1.3 Tallennustiedostojen muoto](#13-tallennustiedostojen-muoto)
- [2. Ohjelman käyttö](#2-ohjelman-käyttö)
   - [2.1 Ohjelman käynnistys](#21-ohjelman-käynnistys)
   - [2.2 Pääikkuna](#22-pääikkuna)
     - [2.2.1 Elokuvan lisääminen](#221-elokuvan-lisääminen)
     - [2.2.2 Arvostelun lisääminen](#222-arvostelun-lisääminen)
     - [2.2.3 Järjestäminen](#223-järjestäminen)
     - [2.2.4 Muokkaaminen](#224-muokkaaminen)
     - [2.2.5 Muu mainittava](#225-muu-mainittava)
     - [2.2.6 Tallenna](#226-tallenna)
- [3. CRC-kortit](#3-crc-kortit)
   - [3.1 Elokuva-luokka (Elokuva)](#31-elokuva-luokka-elokuva)
   - [3.2 Elokuvat-luokka (Elokuvat)](#32-elokuvat-luokka-elokuvat)
   - [3.3 Arvostelu-luokka (Arvostelu)](#33-arvostelu-luokka-arvostelu)
   - [3.4 Arvostelut-luokka (Arvostelut)](#34-arvostelut-luokka-arvostelut)
   - [3.5 Genre-luokka (Genre)](#35-genre-luokka-genre)
   - [3.6 Genret-luokka (Genret)](#36-genret-luokka-genret)
   - [3.7 Kirjasto-luokka (Kirjasto)](#37-kirjasto-luokka-kirjasto)
   - [3.8 Näyttö-luokka (Naytto)](#38-näyttö-luokka-naytto)
- [4. Tietorakennekuva](#4-tietorakennekuva)

# 1. Elokuvakirjasto
Ohjelman tarkoituksena on pitää kirjaa elokuvista ja arvostella niitä.

## 1.1 Mitä tietoja elokuvissa on?
- Nimi
- Ohjaaja
- Julkaisuvuosi
- Elokuvan kesto
- Elokuvagenre
- Oma arvosana
- Oma arvostelu

## 1.2 Mitä ominaisuuksia kirjastolta halutaan?
- Elokuvien lisääminen
- Elokuvien poistaminen
- Tietyn elokuvan hakeminen
- Tietyn elokuvan tietojen muuttaminen
- Elokuvien järjestäminen tiettyjen asioiden kuten nimen mukaan
- Oman arvostelun lisääminen elokuviin
- jne...

## 1.3 Tallennustiedostojen muoto
Ohjelman tiedot tallennetaan seuraavanlaisiin teksti tiedostoihin:

`kirjasto\elokuvat.dat` - elokuva lista<br>
```
; Elokuvatiedot
elokuvaID   | nimi                        | ohjaaja         | vuosi | kestomin | genreIDs |
1           | The Fellowship of the Ring  | Peter Jackson   | 2001  | 178      | 3,8,2    |
2           | Spirited Away               | Hayao Miyazaki  | 2001  | 125      | 1,3,8    |
```


`kirjasto\genre.dat` - Genret elokuville<br>
```
; Genretiedot
genreID   | nimi
1         | Animaatio
2         | Draama
3         | Fantasia
4         | Kauhu
5         | Komedia
6         | Romanssi
7         | Sci-Fi
8         | Seikkailu
9         | Toiminta
10        | Trilleri
```

`kirjasto\arvostelut.dat` - Arvostelut elokuville<br>
```
; Arvostelutiedot
arvosteluID   | elokuvaID | arvosana | kommentti       |
1             | 1         | 10       | Hyvä leffa      |
2             | 2         | 10       | Myös hyvä leffa |
```

# 2. Ohjelman käyttö
## 2.1 Ohjelman käynnistys
Ohjelma käynnistetään klikkaamalla elokuva.jar-ikonia tai antamalla komentoriviltä komento<br>
```
java -jar elokuvakirjasto.jar
```

Kun ohjelma käynnistyy, tulostuu näyttöön<br>
![](kuvat/alkunakyma_scene.png)

Käyttäjä voi nyt luoda oman elokuva kirjaston tai kirjoittaa jo olemassa olevan kirjaston, jonka tiedot sitten haetaan ohjelmaan

## 2.2 Pääikkuna
Kun ohjelma on käynnistynyt on näkyvillä ohjelman pääikkuna:<br>
![](kuvat/paaikkuna_scene.png)

Pääikkunassa on seuraava menurakenne:<br>
```
Tiedosto          Muokkaa                 Apua
========          =======                 =====
Tallenna          Lisää uusi elokuva      Apua
Avaa...           Muokkaa elokuvaa        Tietoja...
Poistu            Poista elokuva       
                  Lisää uusi arvostelu
                  Muokkaa arvostelua
                  Poista arvostelu...
```

### 2.2.1 Elokuvan lisääminen
Painamalla lisää elokuva painiketta alhaalta tai muokkaa valikosta, aukeaa näyttöön uusi ikkuna, jossa on tekstiruutuja, ne täyttämällä voit lisätä uuden elokuvan, tai muokata olemassaolevaa<br>
![](kuvat/lisaa_elokuva_scene.png)

Jos annat tietoa väärässä formaatissa varoittaa tekstikenttä siitä.

### 2.2.2 Arvostelun lisääminen
Arvostelu voidaan lisätä "Lisää arvostelu" näppäimestä tai muokkaa valikosta.<br>
![](kuvat/lisaa_arvostelu_scan.png)

### 2.2.3 Järjestäminen
Voit järjestää elokuvia eri ehtojen, kuten nimen mukaan.  
Myös hakupalkki löytyy vasemmasta yläkulmasta, jonka avulla voit hakea tietyn elokuvan.

### 2.2.4 Muokkaaminen
Valittuja elokuvia voi muokata menemällä halutun tietokentän kohdalle ja tuplaklikkaamalla sitä, tämä avaa saman ikkunan mitä käytetään elokuvan lisäämisessä.  
Sama muokkaaminen toimii myös arvosteluissa.

### 2.2.5 Muu mainittava
**Formatointi päänäkymään**<br> 
Elokuvan kesto minuutteina muutetaan tunneiksi ja minuuteiksi

Genret haetaan elokuvan genreID:itten avulla genret-luokasta, se käy läpi genret yksitellen, antaa ja korvaa valitun elokuvan GenreIDt

### 2.2.6 Tallenna
Tallentaa kaikki muutokset.

...

# 3. CRC-kortit

## 3.1 Elokuva-luokka (Elokuva)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Elokuva                              | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    |                   |
| (- Ei tiedä kirjastosta tai käyttöliittymästä)     |                   |
| - Tietää elokuvan kentät (nimi, ohjaaja, vuosi,    |                   |
|   kesto, genret)                                   |                   |
| - Osaa tarkistaa tietyn kentän oikeellisuuden      |                   |
|   (syntaksin)                                      |                   |
| - osaa muuttaa 1|Inception|..| - merkkijonon ja    |                   |
|    laittaa ne elokuva-luokan tiedoiksi             |                   |
| - osaa antaa merkkijonona i:n kentän tiedot        |                   |
| - osaa laittaa merkkijonon i:neksi kentäksi        |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|-------------------------------------------------------------------------
```

## 3.2 Elokuvat-luokka (Elokuvat)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Elokuvat                             | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    | - Elokuva         |
| - pitää yllä varsinaista elokuvakirjastoa, eli osaa|                   | 
|   lisätä ja poistaa elokuvia                       |                   | 
| - lukee ja kirjoittaa elokuvat tiedostoon          |                   | 
| - osaa etsiä ja lajitella                          |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|-------------------------------------------------------------------------
```

## 3.3 Arvostelu-luokka (Arvostelu)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Arvostelu                            | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    |                   |
| (- ei tiedä kirjastosta, eikä käyttöliittymästä)   |                   | 
| - tietää arvostelun kentät                         |                   | 
| - osaa tarkistaa tietyn kentän oikeellisuuden      |                   |
|   (syntaksin)                                      |                   | 
| - osaa muuttaa 1|1|10 - merkkijonon                |                   |
|   arvostelun tiedoksi                              |                   | 
| - osaa antaa merkkijonona i:n kentän tiedot        |                   | 
| - osaa laittaa merkkijonon i:neksi kentäksi        |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|-------------------------------------------------------------------------
```

## 3.4 Arvostelut-luokka (Arvostelut)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Arvostelut                           | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    | - Arvostelu       |
| - pitää yllä varsinaista arvostelurekisteriä       |                   | 
|   osaa lisätä ja poistaa arvostelun                |                   | 
| - lukee ja kirjoittaa arvostelut tiedostoon        |                   | 
| - osaa etsiä ja lajitella                          |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|-------------------------------------------------------------------------
```

## 3.5 Genre-luokka (Genre)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Genre                                | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    |                   |
| (- Ei tiedä kirjastosta tai käyttöliittymästä)     |                   |
| - Tietää genren kentät (GenreId, Genre nimi)       |                   |
| - osaa muuttaa 1|Toiminta - merkkijonon ja         |                   |
|    laittaa ne genre  -luokan tiedoiksi             |                   |
| - Osaa antaa genren ID:n                           |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|-------------------------------------------------------------------------
```

## 3.6 Genret-luokka (Genret)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Genret                               | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    | - Genre           |
| - pitää yllä varsinaista genrerekisteriä           |                   | 
| - lukee ja kirjoittaa genret tiedostoon            |                   | 
| - osaa etsiä ja lajitella                          |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|-------------------------------------------------------------------------
```

## 3.7 Kirjasto-luokka (Kirjasto)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Kirjasto                             | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    | - Elokuvat        | 
| - huolehtii Elokuvat ja Arvostelut - luokkien      | - Arvostelut      | 
|   välisestä yhteistyöstä ja välittää näitä tietoja | - Genret          | 
|   pyydettäessä (yksi yhteen toteutus               | - Elokuva         | 
| - Huoletii myös Elokuvat ja Genret välisestä       | - Arvostelu       | 
|   yhteistyöstä (moni moneen)                       | - Genre           | 
| - lukee ja kirjoittaa kirjaston tiedostoon         |                   | 
|   pyytämällä apua avustajiltaan                    |                   |
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|                                                    |                   | 
|-------------------------------------------------------------------------
```

## 3.8 Näyttö-luokka (Naytto)
```
|------------------------------------------------------------------------|
| Luokan nimi:  Naytto                               | Avustajat:        |
|-------------------------------------------------------------------------
| Vastuualueet:                                      |                   |
|                                                    | - Kirjasto        |
| - Hoitaa kaiken näyttöön tulevan tekstin           | - Elokuva         |
| - Hoitaa kaiken teidon pyytämisen käyttäjältä      | - Arvostelu       |
|   (ei tiedä kirjaston, eikä elokuvan yksityskohtia)|                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|                                                    |                   |
|-------------------------------------------------------------------------
```

# 4. Tietorakennekuva
![](kuvat/tietorakenne.png)
