package fxKirjasto;

import javafx.application.Application;
import javafx.application.Platform;
import javafx.stage.Stage;
import javafx.scene.Scene;
import javafx.scene.layout.Pane;
import javafx.fxml.FXMLLoader;
import kirjasto.Kirjasto;

/**
 * @author Gimi
 * @version 29/01/2025
 *
 * Paaohjelma, joka kaynnistaa kirjasto ohjelman
 */
public class KirjastoMain extends Application {
    @Override
    public void start(Stage primaryStage) {
        try {
            FXMLLoader ldr = new FXMLLoader(getClass().getResource("KirjastoGUIView.fxml")); // Haetaan loader
            final Pane root = ldr.load(); // Asetetaan paneeli loaderista
            final KirjastoGUIController kirjastoCtrl = ldr.getController();
            kirjastoCtrl.setHostServices(getHostServices());

            Scene scene = new Scene(root);
            scene.getStylesheets().add(getClass().getResource("kirjasto.css").toExternalForm());
            primaryStage.setScene(scene);
            primaryStage.setTitle("Elokuvat");

            primaryStage.setOnCloseRequest(event -> {
                if ( !kirjastoCtrl.voikoSulkea () ) event.consume();
            });

            Kirjasto kirjasto = new Kirjasto();
            kirjastoCtrl.setKirjasto(kirjasto); // Laitetaan kirjasto cotroller

            primaryStage.show();
            if ( !kirjastoCtrl.avaa() ) Platform.exit(); // Jos avaa() palauttaa false, ohjelma sulkeutuu
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * @param args Ei käytössä
     */
    public static void main(String[] args) {
        launch(args);
    }
}