package fxKirjasto;

import fi.jyu.mit.fxgui.ModalController;
import fi.jyu.mit.fxgui.ModalControllerInterface;
import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.TextField;
import javafx.stage.Stage;

/**
 * Kysytään kirhjasto nimi ja lodaan dialogit
 *
 * @author Erno Pajala
 * @version 12.02.2025
 */
public class KirjastoNimiController implements ModalControllerInterface<String> {

    @FXML private TextField textVastaus;
    private String vastaus = null; // Annettu teksti


    // Painettaessa Ok kaydaan hakemassa kirjoitettu teksti
    @FXML private void handleOK(ActionEvent actionEvent) {
        vastaus = textVastaus.getText();
        ModalController.closeStage(textVastaus); // Suljetaan ikkuna
    }


    @FXML private void handleCancel(ActionEvent actionEvent) {
        ModalController.closeStage(textVastaus); // Suljetaan ikkuna
    }


    // Palautetaan annettu teksti tai null (oletuksena = null)
    @Override
    public String getResult() {
        return vastaus;
    }


    // Laitetaan oletus teksti tekstikenttaan
    @Override
    public void setDefault(String oletus) {
        textVastaus.setText(oletus);
    }


    // Asetetaan oletus nakyma ikkunalle
    @Override
    public void handleShown() {
        textVastaus.requestFocus();
    }


    /**
     * Luodan nimenkasittelyikkuna ja palautetaan siihen kirjoitettu nimi tai null
     * @param modalityStage Mihin ollaan modaalinen
     * @param oletus Annettu tai oletusnimi
     * @return null jos perutetaan, muuten annettu nimi
     */
    public static String kysyNimi(Stage modalityStage, String oletus) {
        return ModalController.showModal(
                KirjastoNimiController.class.getResource("KirjastoNimiView.fxml"), // Otetaan kirjastoView ikkuna
                "elokuvat",
                modalityStage, oletus);
    }


}
