package kirjasto.test;
// Generated by ComTest BEGIN
import kirjasto.*;
import java.io.*;
import java.util.*;
import static org.junit.Assert.*;
import org.junit.*;
// Generated by ComTest END

/**
 * Test class made by ComTest
 * @version 2025.04.17 22:24:59 // Generated by ComTest
 *
 */
@SuppressWarnings({ "PMD" })
public class ArvostelutTest {



  // Generated by ComTest BEGIN
  /** 
   * testKorvaaTaiLisaa43 
   * @throws SailoException when error
   * @throws CloneNotSupportedException when error
   */
  @Test
  public void testKorvaaTaiLisaa43() throws SailoException,CloneNotSupportedException {    // Arvostelut: 43
    Arvostelut arvostelut = new Arvostelut(); 
    Arvostelu a1 = new Arvostelu(), a2 = new Arvostelu(); 
    a1.rekisteroi(1); a2.rekisteroi(2); 
    arvostelut.korvaaTaiLisaa(a1); 
    arvostelut.korvaaTaiLisaa(a2); 
    Arvostelu a3 = a1.clone(); 
    a3.setKommentti("Hyva leffa"); 
    Iterator<Arvostelu> it = arvostelut.iterator(); 
    assertEquals("From: Arvostelut line: 54", true, it.next() == a1); 
    it = arvostelut.iterator(); 
    Arvostelu a0 = it.next(); 
    assertEquals("From: Arvostelut line: 57", false, a0 == a3); 
    assertEquals("From: Arvostelut line: 58", true, a0 == a1); 
  } // Generated by ComTest END


  // Generated by ComTest BEGIN
  /** 
   * testLueTiedostosta105 
   * @throws SailoException when error
   */
  @Test
  public void testLueTiedostosta105() throws SailoException {    // Arvostelut: 105
    String testiHakemisto = "testidata"; 
    Arvostelut arvostelut = new Arvostelut(); 
    Arvostelu a1 = new Arvostelu(), a2 = new Arvostelu(); 
    a1.rekisteroi(1); a1.taytaArvostelu(1); 
    a2.rekisteroi(2); a2.taytaArvostelu(2); 
    arvostelut.lisaa(a1); 
    arvostelut.lisaa(a2); 
    try {
    arvostelut.lueTiedostosta(testiHakemisto); 
    fail("Arvostelut: 117 Did not throw SailoException");
    } catch(SailoException _e_){ _e_.getMessage(); }
    arvostelut.tallenna(testiHakemisto); 
    Arvostelut uudet = new Arvostelut(); 
    uudet.lueTiedostosta(testiHakemisto); 
    Iterator<Arvostelu> i = uudet.iterator(); 
    assertEquals("From: Arvostelut line: 123", a1.toString(), i.next().toString()); 
    assertEquals("From: Arvostelut line: 124", a2.toString(), i.next().toString()); 
    assertEquals("From: Arvostelut line: 125", false, i.hasNext()); 
    new File(testiHakemisto + "/arvostelut.dat").delete(); 
    new File(testiHakemisto).delete(); 
  } // Generated by ComTest END


  // Generated by ComTest BEGIN
  /** testIterator189 */
  @Test
  public void testIterator189() {    // Arvostelut: 189
    Arvostelut arvosteet = new Arvostelut(); 
    Arvostelu arv21 = new Arvostelu(2); arvosteet.lisaa(arv21); 
    Arvostelu arv11 = new Arvostelu(1); arvosteet.lisaa(arv11); 
    Arvostelu arv22 = new Arvostelu(2); arvosteet.lisaa(arv22); 
    Arvostelu arv12 = new Arvostelu(1); arvosteet.lisaa(arv12); 
    Arvostelu arv23 = new Arvostelu(2); arvosteet.lisaa(arv23); 
    Iterator<Arvostelu> i2=arvosteet.iterator(); 
    assertEquals("From: Arvostelut line: 199", arv21, i2.next()); 
    assertEquals("From: Arvostelut line: 200", arv11, i2.next()); 
    assertEquals("From: Arvostelut line: 201", arv22, i2.next()); 
    assertEquals("From: Arvostelut line: 202", arv12, i2.next()); 
    assertEquals("From: Arvostelut line: 203", arv23, i2.next()); 
    try {
    assertEquals("From: Arvostelut line: 204", arv12, i2.next()); 
    fail("Arvostelut: 204 Did not throw NoSuchElementException");
    } catch(NoSuchElementException _e_){ _e_.getMessage(); }
    int n = 0; 
    int eID[] = { 2,1,2,1,2} ; 
    for ( Arvostelu arv : arvosteet ) {
    assertEquals("From: Arvostelut line: 208", eID[n], arv.getElokuvaID()); n++; 
    }
    assertEquals("From: Arvostelut line: 211", 5, n); 
  } // Generated by ComTest END


  // Generated by ComTest BEGIN
  /** testAnnaArvostelu225 */
  @Test
  public void testAnnaArvostelu225() {    // Arvostelut: 225
    Arvostelut arvosteet = new Arvostelut(); 
    Arvostelu arv21 = new Arvostelu(1); arvosteet.lisaa(arv21); 
    Arvostelu arv11 = new Arvostelu(2); arvosteet.lisaa(arv11); 
    Arvostelu arv22 = new Arvostelu(4); arvosteet.lisaa(arv22); 
    assertEquals("From: Arvostelut line: 231", arv21, arvosteet.annaArvostelu(1)); 
    assertEquals("From: Arvostelut line: 232", arv11, arvosteet.annaArvostelu(2)); 
    assertEquals("From: Arvostelut line: 233", null, arvosteet.annaArvostelu(3)); 
    assertEquals("From: Arvostelut line: 234", arv22, arvosteet.annaArvostelu(4)); 
  } // Generated by ComTest END
}